(vl-load-com)

(defun k_get_interface_object ()
;;; Aktuelle ODBX-Version feststellen, Rckgabewert ist VLA-Object der aktuellen DBX-Variante
  (vl-catch-all-apply
    'vla-getinterfaceobject
    (append
      (list (vlax-get-acad-object))
      (vl-remove-if-not
	'(lambda (eintrag)
	   (wcmatch eintrag
		    (strcat "*" (itoa (atoi (getvar "acadver"))) "*")
	   )
	 )
	(vl-remove-if
	  'not
	  (mapcar
	    (function
	      (lambda (version)
		(if
		  (findfile
		    (vl-registry-read
		      (strcat
			"HKEY_CLASSES_ROOT\\CLSID\\"
			(vl-registry-read
			  (strcat "HKEY_CLASSES_ROOT\\"
				  version
				  "\\CLSID"
			  )
			)
			"\\InProcServer32"
		      )
		    )			;prft, welche dll-Datei fr die ObjectDBX-Version registriert ist, ->
		  )			;wenn file in den Supportpfaden, dann isses gut
		   version
		   nil
		)
	      )
	    )
	    (vl-remove-if-not
	      '(lambda (VARIABLE)
		 (wcmatch VARIABLE "ObjectDBX.AxDbDocument.*")
	       )
	      (vl-registry-descendents "HKEY_CLASSES_ROOT")
	    )				;Rckgabe: Liste aller registrierten ObjectDBX-Versionen
	  )
	)				;Liste mit einer gltigen Version als Text
      )
    )
  )					;Rckgabewert ist VLA-Object der aktuellen DBX-Variante
)

(defun c:k_odbx_005 (/		   A		 ARRAY
		     BLK_LIST	   BLK_WAHL	 BLOCKS
		     DBX	   DIMSTYLES	 DIMSTYLE_LIST
		     DIMSTYLE_WAHL I		 k_odbx_005_ID
		     LAYERS	   LAYER_LIST	 LAYER_WAHL
		     LINETYPES	   LINETYPE_LIST LTYPE_WAHL
		     MLINE_LIST	   ML_DICT_OBJ	 ML_WAHL
		     OK		   PFAD		 TEXTSTYLES
		     TEXTSTYLE_LIST		 TEXTSTYLE_WAHL tbl_list
		    )
;;; Definitionen importieren
  (defun k_odbx_005_end	(wert)
    (setq ok wert)
    (setq
      blk_wahl
       (k_nth
	 blk_list
	 (eval (read (strcat "'(" (get_tile "blk_list") ")")))
       )
    )
    (setq
      textstyle_wahl
       (k_nth
	 textstyle_list
	 (eval (read (strcat "'(" (get_tile "textstyle_list") ")")))
       )
    )
    (setq
      ml_wahl
       (k_nth
	 mline_list
	 (eval (read (strcat "'(" (get_tile "mline_list") ")")))
       )
    )
    (setq
      dimstyle_wahl
       (k_nth
	 dimstyle_list
	 (eval (read (strcat "'(" (get_tile "dimstyle_list") ")")))
       )
    )
    (setq
      layer_wahl
       (k_nth
	 layer_list
	 (eval (read (strcat "'(" (get_tile "layer_list") ")")))
       )
    )
    (setq
      ltype_wahl
       (k_nth
	 linetype_list
	 (eval (read (strcat "'(" (get_tile "linetype_list") ")")))
       )
    )
    (setq
      tbl_wahl
       (k_nth
	 tbl_list
	 (eval (read (strcat "'(" (get_tile "tbl_list") ")")))
       )
    )
    (done_dialog wert)
  )

  (defun k_odbx_005_do (obj table)
    (setq obj (list obj))
    (setq ARRAY	(vl-catch-all-apply
		  'vlax-make-safearray
		  (list
		    vlax-vbobject
		    (cons 0 (1- (length obj)))
		  )
		)
    )
    (setq i -1)
    (mapcar '(lambda (A)
	       (vlax-safearray-put-element ARRAY (setq i (1+ i)) A)
	     )
	    obj
    )
    (not (vl-catch-all-error-p
	   (vl-catch-all-apply
	     'vla-copyobjects ;_ die Definitionen in die Zeichnung kopieren
	     (list ;_dabei evtl. Fehler abfangen
	       DBX
	       ARRAY
	       table
	     )
	   )
	 )
    )
  )

  (if (setq pfad (getfiled "Datei whlen" (getvar "DWGPREFIX") "dwg" 2))
    (progn
      (vla-open	(setq dbx (k_get_interface_object))
		pfad
      )
;;; Blcke
      (if (setq blocks (vla-get-blocks DBX))
	(progn
	  (vlax-for blk	blocks
	    (if	(= (vla-get-islayout blk) :vlax-false)
	      (setq blk_list
		     (cons (list (vla-get-name blk) blk)
			   blk_list
		     )
	      )
	    )
	  )
	)
      )
;;; Textstile
      (if (setq textstyles (vla-get-textstyles DBX))
	(progn
	  (vlax-for textstyle textstyles
	    (setq textstyle_list
		   (cons (list (vla-get-name textstyle) textstyle)
			 textstyle_list
		   )
	    )
	  )
	)
      )
;;; Multilinienstile
      (if (setq	ml_dict_obj
		 (vla-item (vla-get-Dictionaries dbx)
			   "ACAD_MLINESTYLE"
		 )
	  )
	(vlax-for mlstyle ml_dict_obj
	  (setq	mline_list
		 (cons
		   (list
		     (cdr
		       (assoc 2
			      (entget
				(vlax-vla-object->ename mlstyle)
			      )
		       )
		     )
		     mlstyle
		   )
		   mline_list
		 )
	  )
	)
      )
;;; Bemaungsstile
      (if (setq dimstyles (vla-get-dimstyles DBX))
	(progn
	  (vlax-for dimstyle dimstyles
	    (setq dimstyle_list
		   (cons (list (vla-get-name dimstyle) dimstyle)
			 dimstyle_list
		   )
	    )
	  )
	)
      )
;;; Layer
      (if (setq layers (vla-get-layers DBX))
	(progn
	  (vlax-for layer layers
	    (setq layer_list
		   (cons (list (vla-get-name layer) layer)
			 layer_list
		   )
	    )
	  )
	)
      )
;;; Linientypen
      (if (setq linetypes (vla-get-linetypes DBX))
	(progn
	  (vlax-for linetype linetypes
	    (setq linetype_list
		   (cons (list (vla-get-name linetype) linetype)
			 linetype_list
		   )
	    )
	  )
	)
      )
;;; Tabellenstile
      (if (setq	tbl_dict_obj
		 (vla-item (vla-get-Dictionaries dbx)
			   "ACAD_TABLESTYLE"
		 )
	  )
	(vlax-for tblstyle tbl_dict_obj
	  (setq	tbl_list
		 (cons
		   (list (vla-get-name tblstyle) tblstyle)
		   tbl_list
		 )
	  )
	)
      )
;;;

      (setq k_odbx_005_id (load_dialog "k_func.dcl"))
      (if (not (new_dialog "k_odbx_005_dialog" k_odbx_005_id))
	(exit)
      )

      (start_list "blk_list")
      (mapcar 'add_list (mapcar 'car blk_list))
      (end_list)
      (start_list "textstyle_list")
      (mapcar 'add_list (mapcar 'car textstyle_list))
      (end_list)
      (start_list "mline_list")
      (mapcar 'add_list (mapcar 'car mline_list))
      (end_list)
      (start_list "dimstyle_list")
      (mapcar 'add_list (mapcar 'car dimstyle_list))
      (end_list)
      (start_list "layer_list")
      (mapcar 'add_list (mapcar 'car layer_list))
      (end_list)
      (start_list "linetype_list")
      (mapcar 'add_list (mapcar 'car linetype_list))
      (end_list)
      (start_list "tbl_list")
      (mapcar 'add_list (mapcar 'car tbl_list))
      (end_list)

      (action_tile "accept" "(k_odbx_005_end 1)")
      (action_tile "cancel" "(k_odbx_005_end 0)")
      (start_dialog)
      (unload_dialog k_odbx_005_id)
      (if (= ok 1)
	(progn
;;; Blcke
	  (foreach data	blk_wahl
	    (k_odbx_005_do
	      (cadr data)
	      (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object)))
	    )
	  )
;;; Textstile
	  (foreach data	textstyle_wahl
	    (k_odbx_005_do
	      (cadr data)
	      (vla-get-textstyles (vla-get-activedocument (vlax-get-acad-object)))
	    )
	  )
;;; Multilinienstile
	  (foreach data	ml_wahl
	    (k_odbx_005_do
	      (cadr data)
	      (vla-item	(vla-get-Dictionaries (vla-get-activedocument (vlax-get-acad-object)))
			"ACAD_MLINESTYLE"
	      )
	    )
	  )
;;; Bemaungsstile
	  (foreach data	dimstyle_wahl
	    (k_odbx_005_do
	      (cadr data)
	      (vla-get-dimstyles (vla-get-activedocument (vlax-get-acad-object)))
	    )
	  )
;;; Layer
	  (foreach data	layer_wahl
	    (k_odbx_005_do
	      (cadr data)
	      (vla-get-layers (vla-get-activedocument (vlax-get-acad-object)))
	    )
	  )
;;; Linientypen
	  (foreach data	ltype_wahl
	    (k_odbx_005_do
	      (cadr data)
	      (vla-get-linetypes (vla-get-activedocument (vlax-get-acad-object)))
	    )
	  )

	)
      )
;;; Tabellenstile
      (foreach data tbl_wahl
	(k_odbx_005_do
	  (cadr data)
	  (vla-item (vla-get-Dictionaries (vla-get-activedocument (vlax-get-acad-object)))
		    "ACAD_TABLESTYLE"
	  )
	)
      )
;;;      
      (not (vl-catch-all-error-p
	     (vl-catch-all-apply
	       'vlax-release-object
	       (list DBX) ;_DBX-Verknfung wieder freigeben
	     )
	   )
      )
      (princ)
    )
  )
  (princ)
)